/*C Program 7   CSCI 2320.003
  Scott Dudley  baz006

  This is a program that will convert a user-specified interger
  value into its Roman Numeral equivelent.
*/

#include  <stdio.h>
#include  <ctype.h>
#include  "course.h"
void DispNumeral(unsigned int num,char unit,char five,char ten)
/*This function will take a single digit and convet it into its
  Roman Numeral equivalent. It will also allow you to specify
  what three characters to use for units, fives, and tens.*/
 {unsigned char count;
  if (num!=0)
    {
    if(num <= 3)
     {
      for(count=1; count <= num; count++)
	putchar (unit);
     }
    else if(num == 4)
     {
      putchar(unit);
      putchar(five);
     }
    else if(num < 9)
     {
      putchar(five);
      for (count=6; count <=num; count++)
	putchar (unit);
     }
    else
     {
      putchar(unit);
      putchar(ten);
     }
  }
 }
void beepbad()
/*A sound to be played when an error has occured*/
 {
    sound(700);
    delay(30);
    sound(500);
    delay(40);
    sound(300);
    delay(50);
    nosound();
 }
void beepgood()
/*A sound to be played when everything seems to be working good*/
 {
    sound(500);
    delay(40);
    sound(1000);
    delay(40);
    sound(700);
    delay(40);
    nosound();
 }

void DispTitle()
/*A function to diplay a nice header as the program begins*/
 {  int count;
    clrscr();
    gotoxy(1,25);
    printf("        Ŀ \n");
    printf("    ͵- Scott Dudley    Program 7    CSCI 2320.003    baz006 -۲ \n");
    printf("         \n\n");
    for(count=0;count<20;count++)
     {sound(count*500);printf("\n"); delay(1);nosound();delay(5);}
    beepgood();
    gotoxy(1,5);
 }

void main()
{ int UserNumber;
  DispTitle();

  do
   {
    printf("Enter an whole number from 1 to 8999 (0 to end): ");
    UserNumber=GETINT();
     if (InputError!=0)
      {
       beepbad();
       printf("\nNot a valid interger type number, please enter it again.\n");
       UserNumber=1;  /*If we leave it as a 0 that GETINT returns with an*/
      }               /*invalid entry, then the program will terminate*/
     else if(UserNumber<0)
      {
       beepbad();
       printf("\nThe number is not positive, please enter it again.\n");
      }
     else if(UserNumber>8999)
      {
       beepbad();
       printf("\nThe number is to large, please enter it again.\n");
      }
     else if(UserNumber>0)
      {
       beepgood();
       printf("\nThe Roman Numeral equivalent for %i is: ",UserNumber);
       DispNumeral((UserNumber/1000),'M','V','?');
       DispNumeral(((UserNumber%1000)/100),'C','D','M');
       DispNumeral(((UserNumber%100)/10),'X','L','C');
       DispNumeral((UserNumber%10),'I','V','X');
       printf("\n\n");
      }
   }
  while(UserNumber!=0);


 }

