/*C Program 9   CSCI 2320.003
  Scott Dudley  baz006

  This is a C program that will read two arrays from a data
  file and preform operations on the arrays. The instructions
  did not state that those operations had to be preformed in
  the order listed so I did step 3 and part of 5 in one step.
  Otherwise, I would have had to leave the file open and come
  back to it later...
*/

#include  <stdio.h>

int SmallArray[5]={1,2,3,4,5},
    LargeArray[4][5]={{1,2,3,4,5},{6,7,8,9,10},{11,12,13,14,15},{16,17,18,19,20}};


/*Just your fancy little title displayer..*/
/*It was practice for passing strings to functions. */
void DispTitle(char Line[80+1])
 {unsigned char count1;
  printf("\n\n");
  for(count1=(strlen(Line)-1);count1>0;count1--)
   {
    gotoxy(1,wherey()-1);
    puts(Line+count1);
    delay(5);
   }
  putch('\n');
 }



unsigned int ReadDataFile()
 {int c1,c2;
  unsigned char filename[40+1];
  FILE *datafile;

  printf("Please enter a file name: ");
  gets(filename);
  datafile = fopen(filename,"r");

  if (datafile != NULL) /*file test*/
   {printf("File found and opened.\n");

    for(c1=0;c1<5;c1++)
     fscanf(datafile,"%d",&SmallArray[c1]);

    for(c1=0;c1<4;c1++)
      for(c2=0;c2<5;c2++)
	fscanf(datafile,"%d",&LargeArray[c1][c2]);

    fclose(datafile);
    printf("Data read and file closed.\n\n");
    return(1);
   }

  else
   {printf("\n\nUnable to open file.\n\n");
    return(0);
   }

 }

/*Prints the Small Array..*/
void PrintArray(int ArrayLine[],unsigned char length)
 {int c1;
  for (c1=0;c1<length;c1++)
   {printf ("%5d",ArrayLine[c1]);
   }
  printf("\n");
  printf("\n");
 }


/*Prints the FULL array..*/
void PrintMatrix(int arrayIn[][5],int numRows)
{int c1,c2;
 for (c1=0;c1<numRows;c1++,printf("\n"))
   for (c2=0;c2<5;c2++)
     printf ("%5d ", arrayIn[c1][c2]);
 printf("\n");
 }


/*Prints everything we got*/
void PrintAllArrays()
 {int c1;
  printf("Array>                     (Original)\n");
  PrintArray(SmallArray,5);
  printf("Matrix>                    (Original)\n");
  PrintMatrix(LargeArray,4);
 }


/*Preforms the addition for both arrays*/
void MatrixAdd()
 {int TempArray[4][5],c1,c2;
  for(c1=0;c1<4;c1++)
    for(c2=0;c2<5;c2++)
      TempArray[c1][c2]=LargeArray[c1][c2]+SmallArray[c2];
  printf("Matrix>                    (Addition)\n");
  PrintMatrix(TempArray,4);
 }

/*Preforms the multiplication for both arrays*/
/*I think the this function and the add function might
  coulda been integrated into one, but stuff like that
  always makes the code less readable...*/
void MatrixMulti()
 {int TempArray[4][5],c1,c2;
  for(c1=0;c1<4;c1++)
    for(c2=0;c2<5;c2++)
     TempArray[c1][c2]=LargeArray[c1][c2]*SmallArray[c2];
  printf("Matrix>                    (Multipication)\n");
  PrintMatrix(TempArray,4);
 }

void main()
 {
  DispTitle("    ͵- Scott Dudley    Program 9  "
	    "  CSCI 2320.003    baz006 -۲ ");
  if (ReadDataFile())
   {
    PrintAllArrays();
    MatrixAdd();
    MatrixMulti();
   }
 }

